#!/usr/bin/ruby

#
# ץ
#
# ====================================================================
# ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
# ====================================================================
# 
#    Project              : SagCAD
#    Description          : Script
#    Source               : square_make.rb
# 
#    ----------------------------------
# 
#    License              : GNU General Public License (GPL)
#    Copyright            : (C) 1998-2003 by Yutaka Sagiya
#    email                : kappa@a6s.highway.ne.jp
#                         : yutaka@sagiya.com
#    Begin                : 2003/05/21
#    Last                 : 2003/05/25
# ====================================================================
require "./ruby/diagram.rb"


# --------------------------------------------------------------------
# ϥե
InputFile = "./ruby/sag_out.txt"
InputData = "./ruby/Square_Data.txt"
OutputFile = "./ruby/sag_inp.txt"


# ----------------------------------------------------------
# SagCAD Ϥե뤫ǡɤ߹
io = open(InputData , "r")


while line = io.gets		# 1 Ԥɤ߹
	line.chomp!				# üʸ
	
	
	# Ƭ TRACE ȸʸĤä顢CAD DATA
	# ɽѤƤ롣
	#     
	if /^INPUT,\"x/ =~ line
		inp_x = line.split(",") # (,) ڤΥǡ data() 
		newtext = inp_x[2].gsub(/\"/,'')
		x = newtext.to_f
#		print "x = ",x,"\n"

	elsif /^INPUT,\"y/ =~ line
		inp_y = line.split(",") # (,) ڤΥǡ data() 
		newtext = inp_y[2].gsub(/\"/,'')
		y = newtext.to_f
#		print "y = ",y,"\n"
	
	end
end
io.close



# ----------------------------------------------------------
# SagCAD Ϥե뤫ǡɤ߹
io = open(InputFile , "r")


while line = io.gets		# 1 Ԥɤ߹
	line.chomp!				# üʸ
	
	
	# Ƭ TRACE ȸʸĤä顢CAD DATA
	# ɽѤƤ롣
	#     
	if /^START/ =~ line
#		print io.lineno," : Data Start\n"
		
		while line = io.gets		# 1 Ԥɤ߹
			line.chomp!				# üʸ
			
			# Ƭ TRACE END ȸʸĤä顢¦ while ȴ롣
			if /^END/ =~ line
#				print io.lineno," : Data End\n"
				break
			end

			if /^POINT/ =~ line
				data = line.split(",") # (,) ڤΥǡ data() 
				cx = data[4].to_f
				cy = data[5].to_f

#				print "POINT (",cx," , ",cy,")\n"
			end
		end
	
	elsif /^NOW_LAYER/ =~ line
		inp_layer = line.split(",") # (,) ڤΥǡ data() 
		layer = inp_layer[1].to_i
#		print "NOW_LAYER = ",layer,"\n"

	elsif /^NOW_COLOR/ =~ line
		inp_color = line.split(",") # (,) ڤΥǡ data() 
		color = inp_color[1].to_i
#		print "NOW_COLOR = ",color,"\n"
	
	elsif /^NOW_STYLE/ =~ line
		inp_style = line.split(",") # (,) ڤΥǡ data() 
		style = inp_style[1].to_i
#		print "NOW_STYLE = ",style,"\n"
	
	end
end
io.close





# ----------------------------------------------------------
# ե˽
io = open(OutputFile , "w")

io.print "START\n"

x = x / 2.0
y = y / 2.0

#LINE,layer,color,style,sx,sy,ex,ey
io.print "LINE,",layer,",",color,",",style,",",(cx+x),",",(cy-y),",",cx+x,",",cy+y,"\n"
io.print "LINE,",layer,",",color,",",style,",",cx+x,",",cy+y,",",cx-x,",",cy+y,"\n"
io.print "LINE,",layer,",",color,",",style,",",cx-x,",",cy+y,",",cx-x,",",cy-y,"\n"
io.print "LINE,",layer,",",color,",",style,",",cx-x,",",cy-y,",",cx+x,",",cy-y,"\n"

io.print "END\n"
io.print "EOF\n"

io.close
#print "꥿󥭡򲡤Ƥλޤ"
#gets
__END__
